View a markdown version of this page

Chame uma ferramenta em um AgentCore gateway - Amazon Bedrock AgentCore

Chame uma ferramenta em um AgentCore gateway

Para chamar uma ferramenta específica, faça uma solicitação POST para o endpoint MCP do gateway e especifique tools/call como método no corpo da solicitação, o nome da ferramenta e os argumentos:

POST /mcp HTTP/1.1 Host: ${GatewayEndpoint} Content-Type: application/json Authorization: ${Authorization header} ${RequestBody}

Substitua os valores a seguir:

  • ${GatewayEndpoint}— O URL do gateway, conforme fornecido na resposta da CreateGatewayAPI.

  • ${Authorization header}— As credenciais de autorização do provedor de identidade quando você configura a autorização de entrada.

  • ${RequestBody}— A carga JSON do corpo da solicitação, conforme especificado em Ferramentas de chamada no Model Context Protocol (MCP). Inclua tools/call como method e inclua a name da ferramenta e suasarguments.

A resposta retorna o conteúdo retornado pela ferramenta e os metadados associados.

Exemplos de código para ferramentas de chamada

Para ver exemplos de listagem de ferramentas disponíveis no gateway, selecione um dos seguintes métodos:

exemplo
curl
  1. A solicitação curl a seguir mostra um exemplo de solicitação para chamar uma ferramenta chamada searchProducts por meio de um gateway com o IDmygateway-abcdefghij.

    curl -X POST \ https://mygateway-abcdefghij.gateway.bedrock-agentcore.us-west-2.amazonaws.com/mcp \ -H "Content-Type: application/json" \ -H "Authorization: Bearer YOUR_ACCESS_TOKEN" \ -d '{ "jsonrpc": "2.0", "id": "invoke-tool-request", "method": "tools/call", "params": { "name": "searchProducts", "arguments": { "query": "wireless headphones", "category": "Electronics", "maxResults": 2, "priceRange": { "min": 50.00, "max": 200.00 } } } }'
Python requests package
  1. import requests import json def call_tool(gateway_url, access_token, tool_name, arguments): headers = { "Content-Type": "application/json", "Authorization": f"Bearer {access_token}" } payload = { "jsonrpc": "2.0", "id": "call-tool-request", "method": "tools/call", "params": { "name": tool_name, "arguments": arguments } } response = requests.post(gateway_url, headers=headers, json=payload) return response.json() # Example usage gateway_url = "https://${GatewayEndpoint}/mcp" # Replace with your actual gateway endpoint access_token = "${AccessToken}" # Replace with your actual access token result = call_tool( gateway_url, access_token, "openapi-target-1___get_orders_byId", # Replace with <{TargetId}__{ToolName}> {"orderId": "ORD-12345-67890", "customerId": "CUST-98765"} ) print(json.dumps(result, indent=2))
MCP Client
  1. from mcp import ClientSession from mcp.client.streamable_http import streamablehttp_client import asyncio async def execute_mcp( url, token, tool_params, headers=None ): default_headers = { "Authorization": f"Bearer {token}" } headers = {**default_headers, **(headers or {})} async with streamablehttp_client( url=url, headers=headers, ) as ( read_stream, write_stream, callA, ): async with ClientSession(read_stream, write_stream) as session: # 1. Perform initialization handshake print("Initializing MCP...") _init_response = await session.initialize() print(f"MCP Server Initialize successful! - {_init_response}") # 2. Call specific tool print(f"Calling tool: {tool_params['name']}") tool_response = await session.call_tool( name=tool_params['name'], arguments=tool_params['arguments'] ) print(f"Tool response: {tool_response}") return tool_response async def main(): url = "https://${GatewayEndpoint}/mcp" token = "your_bearer_token_here" tool_params = { "name": "LambdaTarget___get_order_tool", "arguments": { "orderId": "order123" } } await execute_mcp( url=url, token=token, tool_params=tool_params ) if __name__ == "__main__": asyncio.run(main())
Strands MCP Client
  1. NOTA: Isso é para invocar o agente

    from strands.tools.mcp.mcp_client import MCPClient from mcp.client.streamable_http import streamablehttp_client def create_streamable_http_transport(mcp_url: str, access_token: str): return streamablehttp_client(mcp_url, headers={"Authorization": f"Bearer {access_token}"}) def run_agent(mcp_url: str, access_token: str): mcp_client = MCPClient(lambda: create_streamable_http_transport(mcp_url, access_token)) with mcp_client: result = mcp_client.call_tool_sync( tool_use_id="tool-123", # A unique ID for the tool call name="openapi-target-1___get_orders", # The name of the tool to invoke arguments={} # A dictionary of arguments for the tool ) print(result) url = {gatewayUrl} token = {AccessToken} run_agent(url, token)
LangGraph MCP Client
  1. NOTA: Isso é para invocar o agente

    import asyncio from langgraph.prebuilt import create_react_agent def execute_agent( user_prompt, model_id, region, tools ): model = ChatBedrock(model_id=model_id, region_name=region) agent = create_react_agent(model, tools) _response = asyncio.run(agent.ainvoke({ "messages": user_prompt })) _response = _response.get('messages', {})[1].content print( f"Invoke Langchain Agents Response" f"Response - \n{_response}\n" ) return _response

Erros

A tools/call operação pode retornar os seguintes tipos de erros:

  • Erros retornados como parte do código de status HTTP:

    AuthenticationError

    A solicitação falhou devido a credenciais de autenticação inválidas.

    Código de status HTTP: 401

    AuthorizationError

    O chamador não tem permissão para invocar a ferramenta.

    Código de status HTTP: 403

    ResourceNotFoundError

    A ferramenta especificada não existe.

    Código de status HTTP: 404

    ValidationError

    Os argumentos fornecidos não estão em conformidade com o esquema de entrada da ferramenta.

    Código de status HTTP: 400

    ToolExecutionError

    Ocorreu um erro ao executar a ferramenta.

    Código de status HTTP: 500

    InternalServerError

    Ocorreu um erro interno do servidor.

    Código de status HTTP: 500

  • Erros de MCP. Para obter mais informações sobre esses tipos de erros, consulte Tratamento de erros na documentação do Model Context Protocol (MCP).